<HTML>
<BODY BGCOLOR="white">
<PRE>
<FONT color="green">001</FONT>    /*<a name="line.1"></a>
<FONT color="green">002</FONT>     * =============================================================================<a name="line.2"></a>
<FONT color="green">003</FONT>     * Simplified BSD License, see http://www.opensource.org/licenses/<a name="line.3"></a>
<FONT color="green">004</FONT>     * -----------------------------------------------------------------------------<a name="line.4"></a>
<FONT color="green">005</FONT>     * Copyright (c) 2008-2009, Marco Terzer, Zurich, Switzerland<a name="line.5"></a>
<FONT color="green">006</FONT>     * All rights reserved.<a name="line.6"></a>
<FONT color="green">007</FONT>     * <a name="line.7"></a>
<FONT color="green">008</FONT>     * Redistribution and use in source and binary forms, with or without <a name="line.8"></a>
<FONT color="green">009</FONT>     * modification, are permitted provided that the following conditions are met:<a name="line.9"></a>
<FONT color="green">010</FONT>     * <a name="line.10"></a>
<FONT color="green">011</FONT>     *     * Redistributions of source code must retain the above copyright notice, <a name="line.11"></a>
<FONT color="green">012</FONT>     *       this list of conditions and the following disclaimer.<a name="line.12"></a>
<FONT color="green">013</FONT>     *     * Redistributions in binary form must reproduce the above copyright <a name="line.13"></a>
<FONT color="green">014</FONT>     *       notice, this list of conditions and the following disclaimer in the <a name="line.14"></a>
<FONT color="green">015</FONT>     *       documentation and/or other materials provided with the distribution.<a name="line.15"></a>
<FONT color="green">016</FONT>     *     * Neither the name of the Swiss Federal Institute of Technology Zurich <a name="line.16"></a>
<FONT color="green">017</FONT>     *       nor the names of its contributors may be used to endorse or promote <a name="line.17"></a>
<FONT color="green">018</FONT>     *       products derived from this software without specific prior written <a name="line.18"></a>
<FONT color="green">019</FONT>     *       permission.<a name="line.19"></a>
<FONT color="green">020</FONT>     * <a name="line.20"></a>
<FONT color="green">021</FONT>     * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" <a name="line.21"></a>
<FONT color="green">022</FONT>     * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE <a name="line.22"></a>
<FONT color="green">023</FONT>     * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE <a name="line.23"></a>
<FONT color="green">024</FONT>     * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE <a name="line.24"></a>
<FONT color="green">025</FONT>     * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR <a name="line.25"></a>
<FONT color="green">026</FONT>     * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF <a name="line.26"></a>
<FONT color="green">027</FONT>     * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS <a name="line.27"></a>
<FONT color="green">028</FONT>     * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN <a name="line.28"></a>
<FONT color="green">029</FONT>     * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) <a name="line.29"></a>
<FONT color="green">030</FONT>     * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE <a name="line.30"></a>
<FONT color="green">031</FONT>     * POSSIBILITY OF SUCH DAMAGE.<a name="line.31"></a>
<FONT color="green">032</FONT>     * =============================================================================<a name="line.32"></a>
<FONT color="green">033</FONT>     */<a name="line.33"></a>
<FONT color="green">034</FONT>    package ch.javasoft.math.array.parse;<a name="line.34"></a>
<FONT color="green">035</FONT>    <a name="line.35"></a>
<FONT color="green">036</FONT>    import ch.javasoft.math.NumberMatrixConverter;<a name="line.36"></a>
<FONT color="green">037</FONT>    <a name="line.37"></a>
<FONT color="green">038</FONT>    <a name="line.38"></a>
<FONT color="green">039</FONT>    /**<a name="line.39"></a>
<FONT color="green">040</FONT>     * &lt;code&gt;MatrixData&lt;/code&gt; contains matrix data of a certain number type.<a name="line.40"></a>
<FONT color="green">041</FONT>     */<a name="line.41"></a>
<FONT color="green">042</FONT>    public interface MatrixData {<a name="line.42"></a>
<FONT color="green">043</FONT>            <a name="line.43"></a>
<FONT color="green">044</FONT>            /**<a name="line.44"></a>
<FONT color="green">045</FONT>             * Returns the data type internally used to store the matrix values<a name="line.45"></a>
<FONT color="green">046</FONT>             */<a name="line.46"></a>
<FONT color="green">047</FONT>            DataType getDataType();<a name="line.47"></a>
<FONT color="green">048</FONT>            /**<a name="line.48"></a>
<FONT color="green">049</FONT>             * Returns the number of rows in the matrix<a name="line.49"></a>
<FONT color="green">050</FONT>             */<a name="line.50"></a>
<FONT color="green">051</FONT>            int getRowCount();<a name="line.51"></a>
<FONT color="green">052</FONT>            /**<a name="line.52"></a>
<FONT color="green">053</FONT>             * Returns the number of columns in the matrix<a name="line.53"></a>
<FONT color="green">054</FONT>             */<a name="line.54"></a>
<FONT color="green">055</FONT>            int getColumnCount();<a name="line.55"></a>
<FONT color="green">056</FONT>            /**<a name="line.56"></a>
<FONT color="green">057</FONT>             * Returns a single numeric value of the matrix. The number type is the type<a name="line.57"></a>
<FONT color="green">058</FONT>             * internally used to store the matrix (or its wrapper type).<a name="line.58"></a>
<FONT color="green">059</FONT>             * <a name="line.59"></a>
<FONT color="green">060</FONT>             * @param row   the matrix row<a name="line.60"></a>
<FONT color="green">061</FONT>             * @param col   the matrix column<a name="line.61"></a>
<FONT color="green">062</FONT>             * @return the value from the matrix<a name="line.62"></a>
<FONT color="green">063</FONT>             */<a name="line.63"></a>
<FONT color="green">064</FONT>            Number getValue(int row, int col);<a name="line.64"></a>
<FONT color="green">065</FONT>            /**<a name="line.65"></a>
<FONT color="green">066</FONT>             * Casts the matrix into an array of the specified class and returns it. The <a name="line.66"></a>
<FONT color="green">067</FONT>             * returned matrix is the internally kept matrix instance. Consider using <a name="line.67"></a>
<FONT color="green">068</FONT>             * {@link #getMatrixConverted(NumberMatrixConverter)} instead.<a name="line.68"></a>
<FONT color="green">069</FONT>             * &lt;p&gt;<a name="line.69"></a>
<FONT color="green">070</FONT>             * The polyhedral cone is either defined in hyperplane (ine) or extreme <a name="line.70"></a>
<FONT color="green">071</FONT>             * ray/vertex (ext) format. The returned matrix {@code M} defines a cone as<a name="line.71"></a>
<FONT color="green">072</FONT>             * follows:<a name="line.72"></a>
<FONT color="green">073</FONT>             * &lt;ul&gt;<a name="line.73"></a>
<FONT color="green">074</FONT>             *      &lt;li&gt;ine: &lt;tt&gt;P = { b - Ax &amp;ge; 0} = { Ax &amp;leq; b }, M=[b -A]&lt;/tt&gt;&lt;/li&gt;<a name="line.74"></a>
<FONT color="green">075</FONT>             *      &lt;li&gt;ext: &lt;tt&gt;P = conv(v) + nonneg(r), M=[ v ; r ], v(*,0)=1, r(*,0)=0&lt;/tt&gt;&lt;/li&gt;<a name="line.75"></a>
<FONT color="green">076</FONT>             * &lt;/ul&gt;<a name="line.76"></a>
<FONT color="green">077</FONT>             * <a name="line.77"></a>
<FONT color="green">078</FONT>             * @param       arrayClass      the class of the array into which the matrix is cast <a name="line.78"></a>
<FONT color="green">079</FONT>             * @return the matrix {@code M} as described above<a name="line.79"></a>
<FONT color="green">080</FONT>             * @throws ClassCastException   if the matrix is not an array instance of <a name="line.80"></a>
<FONT color="green">081</FONT>             *                                                              the specified class<a name="line.81"></a>
<FONT color="green">082</FONT>             *  <a name="line.82"></a>
<FONT color="green">083</FONT>             * @see #getMatrixConverted(NumberMatrixConverter)<a name="line.83"></a>
<FONT color="green">084</FONT>             */<a name="line.84"></a>
<FONT color="green">085</FONT>            &lt;A&gt; A[] getMatrixCast(Class&lt;A&gt; arrayClass) throws ClassCastException;<a name="line.85"></a>
<FONT color="green">086</FONT>            /**<a name="line.86"></a>
<FONT color="green">087</FONT>             * Converts the matrix using the specified converter and returns it. The <a name="line.87"></a>
<FONT color="green">088</FONT>             * returned matrix is always a new instance. Consider using <a name="line.88"></a>
<FONT color="green">089</FONT>             * {@link #getMatrixCast(Class)} instead.<a name="line.89"></a>
<FONT color="green">090</FONT>             * &lt;p&gt;<a name="line.90"></a>
<FONT color="green">091</FONT>             * The polyhedral cone is either defined in hyperplane (ine) or extreme <a name="line.91"></a>
<FONT color="green">092</FONT>             * ray/vertex (ext) format. The returned matrix {@code M} defines a cone as<a name="line.92"></a>
<FONT color="green">093</FONT>             * follows:<a name="line.93"></a>
<FONT color="green">094</FONT>             * &lt;ul&gt;<a name="line.94"></a>
<FONT color="green">095</FONT>             *      &lt;li&gt;ine: &lt;tt&gt;P = { b - Ax &amp;ge; 0} = { Ax &amp;leq; b }, M=[b -A]&lt;/tt&gt;&lt;/li&gt;<a name="line.95"></a>
<FONT color="green">096</FONT>             *      &lt;li&gt;ext: &lt;tt&gt;P = conv(v) + nonneg(r), M=[ v ; r ], v(*,0)=1, r(*,0)=0&lt;/tt&gt;&lt;/li&gt;<a name="line.96"></a>
<FONT color="green">097</FONT>             * &lt;/ul&gt;<a name="line.97"></a>
<FONT color="green">098</FONT>             * <a name="line.98"></a>
<FONT color="green">099</FONT>             * @param       converter       the converter used to create the matrix and to <a name="line.99"></a>
<FONT color="green">100</FONT>             *                                              convert the values into the desired format<a name="line.100"></a>
<FONT color="green">101</FONT>             * @return the matrix {@code M} as described above<a name="line.101"></a>
<FONT color="green">102</FONT>             *  <a name="line.102"></a>
<FONT color="green">103</FONT>             * @see #getMatrixCast(Class)<a name="line.103"></a>
<FONT color="green">104</FONT>             */<a name="line.104"></a>
<FONT color="green">105</FONT>            &lt;A&gt; A[] getMatrixConverted(NumberMatrixConverter&lt;A&gt; converter) throws ClassCastException;<a name="line.105"></a>
<FONT color="green">106</FONT>    }<a name="line.106"></a>




























































</PRE>
</BODY>
</HTML>
